/* shared-memory parallel supported with #define PARALLEL */

#if PARALLEL==3
#error PARALLEL==3 in linklist.h
#endif

#ifndef LINKCELL
#error "LINKCELL not #defined"
#endif

typedef struct linklist_s {
  vector r;      /* site position physically here (periodic b.c. optimizing) */
#if PARALLEL==1
  real *f1,*f2;  /* forces indirected:
		    f1 and f2 should point to separate arrays
		    when LJqqm are called in parallel */
/*  int padd[?];    padding to a cache line ? */
#else
  real *f;       /* forces indirected */
#endif
#ifdef POLAR
  vector rpol;   /* polar aux charge physically here */
#if PARALLEL==1
  real *f1pol,*f2pol;  /* forces on aux charge indirected, separate arrays */
#else
  real *fpol;    /* forces on aux charge indirected */
#endif
#endif
  int sp;        /* species */
  int n;         /* number of the molecule containing the site */
  siteinfo_t *si;/* = spec[sp]->si[atom_#] */
  struct linklist_s *next;
  } linklist_t;

extern linklist_t *site_storage;

#if PARALLEL==1
linklist_t ****linklist(vector *f1p,vector *f2p,vector *rp);
#else
linklist_t ****linklist(vector *fp,vector *rp);
#endif

int testlist(char *msg,linklist_t ***list);

void lcsetup(vector L);
